/*->c.csview */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"




#include "str.h"
#include "constants.h"



#include "view.h"
#include "file.h"

#include "dbscale.h"

#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"


#include "prstr.h"


#include "colsep.h"
#include "colseplink.h"



#include "csstr.h"
#include "colsepx.h"
#include "colcode.h"
#include "csink.h"
#include "cscurve.h"
#include "csnaive.h"
#include "csprocess.h"
#include "xpr.h"
#include "icc.h"


#include "csview.h"



int  cscolourmodel;





char cstab16[32]=
{
 0,8,16,25,33,41,49,58,66,74,82,90,99,107,115,123,132,140,148,
 156,165,173,181,189,197,206,214,222,230,239,247,255
};




os_error * colseprgb2hsv(filestr * file,quadstr * rgb,quadstr * hsv)
{
 rgb2hsv(rgb,hsv);
 return(NULL);
 USE(file);
}

os_error * xcolseprgb2hsv(viewstr * view,filestr * file,
                                          quadstr * rgb,quadstr * hsv)
{
 return(colseprgb2hsv(file,rgb,hsv));
 USE(view);
}



os_error * colsephsv2rgb(filestr * file,quadstr * hsv,quadstr * rgb)
{
 hsv2rgb(hsv,rgb);
 return(NULL);
 USE(file);
}


os_error * xcolsephsv2rgb(viewstr * view,filestr * file,
                                          quadstr * hsv,quadstr * rgb)
{
 return(colsephsv2rgb(file,hsv,rgb));
 USE(view);
}





static os_error * colseprgb2cmykp(filestr * file,quadstr * rgb,quadstr * cmyk)
{
 os_error * err;

 err=NULL;

 if(csprintercolourmodel==CSPRINTERPROFILE) err=csprofileprgb2cmyk(rgb,cmyk);
 else
// if(csprintercolourmodel==CSSCREENPROFILE)  err=csprofilergb2cmyk(rgb,cmyk);
// else
 if(csprintercolourmodel==CSCURVEMODEL)     cscurvergb2cmyk(rgb,cmyk);
 else                                       rgb2cmyk(rgb,cmyk);

 return(err);
 USE(file);
}




os_error * colseprgb2cmyk(filestr * file,quadstr * rgb,quadstr * cmyk)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofileprgb2cmyk(rgb,cmyk);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilergb2cmyk(rgb,cmyk);
 else
 if(cscolourmodel==CSCURVEMODEL)     cscurvergb2cmyk(rgb,cmyk);
 else                                rgb2cmyk(rgb,cmyk);

 return(err);
 USE(file);
}



os_error * xcolseprgb2cmyk(viewstr * view,filestr * file,
                                              quadstr * rgb,quadstr * cmyk)
{
 cscolourmodel=(view && view->printview && view->process)?
                                     csprintercolourmodel:csscreencolourmodel;
 return(colseprgb2cmyk(file,rgb,cmyk));
}



os_error * colsepcmyk2rgb(filestr * file,quadstr * cmyk,quadstr * rgb)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofilepcmyk2rgb(cmyk,rgb);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilecmyk2rgb(cmyk,rgb);
 else
 if(cscolourmodel==CSCURVEMODEL)     cscurvecmyk2rgb(cmyk,rgb);
 else
 if(cscolourmodel==CSINKMODEL)       csinkcmyk2rgb(cmyk,rgb);
 else                                cmyk2rgb(cmyk,rgb);

 return(err);
 USE(file);
}



os_error * xcolsepcmyk2rgb(viewstr * view,filestr * file,
                                            quadstr * cmyk,quadstr * rgb)
{
 cscolourmodel=(view && view->printview)?
                                     csprintercolourmodel:csscreencolourmodel;
 colsepcmyk2rgb(file,cmyk,rgb);

 return(NULL);
}



os_error * colsepcmyk2rgb3232(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofilepcmyk2rgb3232(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilecmyk2rgb3232(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvecmyk2rgb3232(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkcmyk2rgb3232(s,d,size);
 else                            cscmyk2rgb3232(s,d,size);

 return(err);
}



os_error * xcolsepcmyk2rgb3232(viewstr * view,int * s,int * d,int size)
{
 cscolourmodel=(view && view->printview)?
                                     csprintercolourmodel:csscreencolourmodel;
 colsepcmyk2rgb3232(s,d,size);

 return(NULL);
}





os_error * colsepcmyk2bgr3232(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofilepcmyk2bgr3232(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilecmyk2bgr3232(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvecmyk2bgr3232(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkcmyk2bgr3232(s,d,size);
 else                            cscmyk2bgr3232(s,d,size);

 return(err);
}



os_error * xcolsepcmyk2bgr3232(viewstr * view,int * s,int * d,int size)
{
 cscolourmodel=(view && view->printview)?
                                     csprintercolourmodel:csscreencolourmodel;
 colsepcmyk2bgr3232(s,d,size);

 return(NULL);
}




static os_error * colseprgb32torgb32p(int * s,int *d,int size,int key,int mask)
{
 os_error * err;

 err=NULL;

 if(csprintercolourmodel==CSPRINTERPROFILE) err=csprofileprgb32torgb32(s,d,size,key,mask);
 else
// if(csprintercolourmodel==CSSCREENPROFILE)  err=csprofilergb32torgb32(s,d,size,key,mask);
// else
 if(csprintercolourmodel==CSCURVEMODEL)     cscurvergb32torgb32(s,d,size,key,mask);
 else
 if(csprintercolourmodel==CSINKMODEL)       csinkrgb32torgb32(s,d,size,key,mask);
 else                                       csrgb32torgb32(s,d,size,key,mask);

 return(err);
}


static os_error * colsepbgr32tobgr32p(int * s,int *d,int size,int key,int mask)
{
 os_error * err;

 err=NULL;

 if(csprintercolourmodel==CSPRINTERPROFILE) err=csprofilepbgr32tobgr32(s,d,size,key,mask);
 else
// if(csprintercolourmodel==CSSCREENPROFILE)  err=csprofilebgr32tobgr32(s,d,size,key,mask);
// else
 if(csprintercolourmodel==CSCURVEMODEL)     cscurvebgr32tobgr32(s,d,size,key,mask);
 else
 if(csprintercolourmodel==CSINKMODEL)       csinkbgr32tobgr32(s,d,size,key,mask);
 else                                       csbgr32tobgr32(s,d,size,key,mask);

 return(err);
}




static os_error * colsepbgr24tobgr24p(int * s,int *d,int size,int key,int mask)
{
 os_error * err;

 err=NULL;

 if(csprintercolourmodel==CSPRINTERPROFILE) err=csprofilepbgr24tobgr24(s,d,size,key,mask);
 else
// if(csprintercolourmodel==CSSCREENPROFILE)  err=csprofilebgr24tobgr24(s,d,size,key,mask);
// else
 if(csprintercolourmodel==CSCURVEMODEL) cscurvebgr24tobgr24(s,d,size,key,mask);
 else
 if(csprintercolourmodel==CSINKMODEL)   csinkbgr24tobgr24(s,d,size,key,mask);
 else                                   csbgr24tobgr24(s,d,size,key,mask);

 return(err);
}






static os_error * colseprgbpaltorgbpalp(int * s,int *d,int size,
                                                             int key,int mask)
{
 os_error * err;
 int        temp;
 int      * p;

 temp=size;
 p=d;

 while(temp--) *p++=(*s++)>>8;
 err=colseprgb32torgb32p(d,d,size,key,mask);
 while(size--) {*d=(*d)<<8;d++;}

 return(err);
}



/*

static os_error * colseprgb32torgb32(int * s,int * d,int size,int key,int mask)
{
 if(cscolourmodel==CSCURVEMODEL) cscurvergb32torgb32(s,d,size,key,mask);
 else
 if(cscolourmodel==CSINKMODEL)   csinkrgb32torgb32(s,d,size,key,mask);
 else                            csrgb32torgb32(s,d,size,key,mask);

 return(NULL);
}

*/






static os_error * colseprgb16torgb16p(int * s,int *d,int size,int key,int mask)
{
 os_error * err;

 err=NULL;

 if(csprintercolourmodel==CSPRINTERPROFILE) err=csprofileprgb16torgb16(s,d,size,key,mask);
 else
// if(csprintercolourmodel==CSSCREENPROFILE)  err=csprofilergb16torgb16(s,d,size,key,mask);
// else
 if(csprintercolourmodel==CSCURVEMODEL) cscurvergb16torgb16(s,d,size,key,mask);
 else
 if(csprintercolourmodel==CSINKMODEL)   csinkrgb16torgb16(s,d,size,key,mask);
 else                                   csrgb16torgb16(s,d,size,key,mask);
                                  
 return(err);
}



static os_error * colsepbgr16tobgr16p(int * s,int *d,int size,int key,int mask)
{
 os_error * err;

 err=NULL;

 if(csprintercolourmodel==CSPRINTERPROFILE) err=csprofilepbgr16tobgr16(s,d,size,key,mask);
 else
// if(csprintercolourmodel==CSSCREENPROFILE)  err=csprofilebgr16tobgr16(s,d,size,key,mask);
// else
 if(csprintercolourmodel==CSCURVEMODEL) cscurvebgr16tobgr16(s,d,size,key,mask);
 else
 if(csprintercolourmodel==CSINKMODEL)   csinkbgr16tobgr16(s,d,size,key,mask);
 else                                   csbgr16tobgr16(s,d,size,key,mask);
                                  
 return(err);
}



/*

static os_error * colseprgb16torgb16(int * s,int * d,int size,int key,int mask)
{
 if(cscolourmodel==CSCURVEMODEL) cscurvergb16torgb16(s,d,size,key,mask);
 else
 if(cscolourmodel==CSINKMODEL)   csinkrgb16torgb16(s,d,size,key,mask);
 else                            csrgb16torgb16(s,d,size,key,mask);

 return(NULL);
}

*/


static os_error * colsepcmyk32torgb32(int * s,int * d,int size,
                                                             int key,int mask)
{
 int tint;


 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=255-((*s++)&0xFF);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=255-((*s++)&0xFF);     /* cyan */
    *d++=0xFFFF00|tint;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=255-(((*s++)>>16)&0xFF);        /* yellow */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=255-(((*s++)>>16)&0xFF);        /* yellow */
    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=255-(((*s++)>>8)&0xFF);         /* magenta */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=255-(((*s++)>>8)&0xFF);         /* magenta */
    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   tint=255-(((*s++)>>24)&0xFF);         /* black */
   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(NULL);
}



static os_error * colsepcmyk32tobgr32(int * s,int * d,int size,
                                                             int key,int mask)
{
 int tint;


 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=255-((*s++)&0xFF);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=255-((*s++)&0xFF);     /* cyan */
    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=255-(((*s++)>>16)&0xFF);        /* yellow */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=255-(((*s++)>>16)&0xFF);        /* yellow */
    *d++=0xFFFF00|(tint);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=255-(((*s++)>>8)&0xFF);         /* magenta */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=255-(((*s++)>>8)&0xFF);         /* magenta */
    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   tint=255-(((*s++)>>24)&0xFF);         /* black */
   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(NULL);
}






os_error * colseprgb2cmyk3232(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofileprgb2cmyk3232(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilergb2cmyk3232(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvergb2cmyk3232(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkrgb2cmyk3232(s,d,size);
 else                            csrgb2cmyk3232(s,d,size);

 return(err);
}



/*

os_error *  colseprgb2cmykpal32(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofileprgb2cmykpal32(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilergb2cmykpal32(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvergb2cmykpal32(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkrgb2cmykpal32(s,d,size);
 else                            csrgb2cmykpal32(s,d,size);

 return(err);
}


os_error *  colsepcmyk2rgb32pal(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofilepcmyk2rgb32pal(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilecmyk2rgb32pal(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvecmyk2rgb32pal(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkcmyk2rgb32pal(s,d,size);
 else                            cscmyk2rgb32pal(s,d,size);

 return(err);
}


os_error *  colseprgb2cmyk1632(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofileprgb2cmyk1632(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilergb2cmyk1632(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvergb2cmyk1632(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkrgb2cmyk1632(s,d,size);
 else                            csrgb2cmyk1632(s,d,size);

 return(err);
}


os_error *  colsepcmyk2rgb3216(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 if(cscolourmodel==CSPRINTERPROFILE) err=csprofilepcmyk2rgb3216(s,d,size);
 else
 if(cscolourmodel==CSSCREENPROFILE)  err=csprofilecmyk2rgb3216(s,d,size);
 else
 if(cscolourmodel==CSCURVEMODEL) cscurvecmyk2rgb3216(s,d,size);
 else
 if(cscolourmodel==CSINKMODEL)   csinkcmyk2rgb3216(s,d,size);
 else                            cscmyk2rgb3216(s,d,size);

 return(err);
}

*/




/* because this function is either going to a printer, or showing */
/* seps on screen, it always uses csprintercolourmodel            */



static os_error * svprocess(viewstr * view,void * d,void * s,int size,
                            int dtype,int stype,cmsdatastr * scms,cmsdatastr * dcms)
{
 colourvalue     * cv;
 int             * pal;
 int               spot;
 int               key;
 colourstr       * cs;
 filestr         * file;
 int               byte;
 quadstr           q1;
 quadstr           q2;
 int               tint;
 colsepobjectstr * csp;
 colplatestr     * platep;
 int               mask;



 file=view->file;

 if(view->printview)
 {
  csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);
  platep=csp->data.plate+(view->processvalue & PLATEMASK);
  spot=platep->spot;
  key=platep->colour;
  if(view->processvalue & COPYSEP) mask=0xFFFFFFFF;
  else                             mask=0x0;
 }
 else
 {
  spot=(view->processvalue & SPOTMASK);
  key=view->processvalue & COLMASK;
  mask=0xFFFFFFFF;
 }


 if(stype==PROCESST_RGB32)
 {
  colseprgb32torgb32p((int*)s,(int*)d,size,key,mask);
 }
 else
 if(stype==PROCESST_BGR32)
 {
  colsepbgr32tobgr32p((int*)s,(int*)d,size,key,mask);
 }
 else
 if(stype==PROCESST_BGR24)
 {
  colsepbgr24tobgr24p((int*)s,(int*)d,size,key,mask);
 }
 else
 if(stype==PROCESST_RGB16)
 {
  colseprgb16torgb16p((int*)s,(int*)d,size,key,mask);
 }
 else
 if(stype==PROCESST_BGR16)
 {
  colsepbgr16tobgr16p((int*)s,(int*)d,size,key,mask);
 }
 else
 if(stype==PROCESST_PAL)
 {
  colseprgbpaltorgbpalp((int*)s,(int*)d,size,key,mask);
 }
 else
 if(stype==PROCESST_CMYK)
 {
  if(dtype==PROCESST_RGB32)
  {
   colsepcmyk32torgb32((int*)s,(int*)d,size,key,mask);
  }
  else
  if(dtype==PROCESST_BGR32)
  {
   colsepcmyk32tobgr32((int*)s,(int*)d,size,key,mask);
  }
 }
 else
 if(stype==PROCESST_COLVAL)
 {
  cv=(colourvalue*)s;
  pal=(int*)d;

  if(spot)
  {
   while(size--)
   {
    if(cv->data.tint.key==(unsigned)key)  /* and spot and spot colour */
    {                           /* go for it                */
     findcoloursp(key,&cs,file);
    /* if(mask==0) */
     {
      byte=((MAXTINT-cv->data.tint.tint)*255)/MAXTINT;
      *pal++=(byte<<24)|(byte<<16)|(byte<<8);
     }
   /*  else
     {
      byte=255+((cs->pal-255)*cv->data.tint.tint)/MAXTINT;

     } */
    }
    else
    {
     findcoloursp(cv->data.tint.key,&cs,file);

     if(cs->flags & COLOURALLPLATES)
     {
      byte=((MAXTINT-cv->data.tint.tint)*255)/MAXTINT;
      *pal++=(byte<<24)|(byte<<16)|(byte<<8);
     }
     else
     if((cs->flags & COLOURTRANS) || 
        ((cs->flags & COLOURNOPRINT) && view->printview))
     {
      *pal++=-1;
     }
     else
     if(cs->flags & COLOUROVERPRINT)
     {
      if(cv->data.tint.tint>=cs->overprintlimit) *pal++=-1;
      else                                       *pal++=0xFFFFFF00;
     }
     else
     if(cv->data.tint.overprint)
     {
      *pal++=-1;
     }
     else
     {
      *pal++=0xFFFFFF00;
     }
    }
    cv++;
   }
  }
  else
  {
   while(size--)
   {
    findcoloursp(cv->data.tint.key,&cs,file);

    if((cs->flags & COLOURTRANS) ||
       ((cs->flags & COLOURNOPRINT) && view->printview))
    {
     *pal++=-1;
    }
    else
    if(cs->flags & COLOURPLATE)   /* spot colour */
    {
     if(cs->flags & COLOUROVERPRINT)
     {
      if(cv->data.tint.tint>=cs->overprintlimit) *pal++=-1;
      else                                       *pal++=0xFFFFFF00;
     }
     else
     if(cv->data.tint.overprint)
     {
      *pal++=-1;
     }
     else
     {
      *pal++=0xFFFFFF00;
     }
    }
    else
    {
     if(cs->model.no==RGBMODEL)
     {
      tint=cv->data.tint.tint>>2;

      q1.type.rgb.r=
        ((MAXTINT2-tint)*MAXCV+tint*cs->model.data.quad.type.rgb.r)/MAXTINT2;
      q1.type.rgb.g=
        ((MAXTINT2-tint)*MAXCV+tint*cs->model.data.quad.type.rgb.g)/MAXTINT2;
      q1.type.rgb.b=
        ((MAXTINT2-tint)*MAXCV+tint*cs->model.data.quad.type.rgb.b)/MAXTINT2;

      colseprgb2cmykp(file,&q1,&q2);
     }
     else
     if(cs->model.no==HSVMODEL)
     {
      tint=cv->data.tint.tint>>2;

      hsv2rgb(&cs->model.data.quad,&q2);

      q1.type.rgb.r=((MAXTINT2-tint)*MAXCV+tint*q2.type.rgb.r)/MAXTINT2;
      q1.type.rgb.g=((MAXTINT2-tint)*MAXCV+tint*q2.type.rgb.g)/MAXTINT2;
      q1.type.rgb.b=((MAXTINT2-tint)*MAXCV+tint*q2.type.rgb.b)/MAXTINT2;

      colseprgb2cmykp(file,&q1,&q2);
     }
     else
     if(cs->model.no==CMYKMODEL)
     {
      tint=cv->data.tint.tint>>2;

      q2.type.cmyk.c=(tint*cs->model.data.quad.type.cmyk.c)/MAXTINT2;
      q2.type.cmyk.m=(tint*cs->model.data.quad.type.cmyk.m)/MAXTINT2;
      q2.type.cmyk.y=(tint*cs->model.data.quad.type.cmyk.y)/MAXTINT2;
      q2.type.cmyk.k=(tint*cs->model.data.quad.type.cmyk.k)/MAXTINT2;
     }

     if(key==KEYCYAN)
     {
      if(q2.type.cmyk.c==0)
      {
       if((cs->flags & COLOUROVERPRINT) || cv->data.tint.overprint) *pal++=-1;
       else                                                 *pal++=0xFFFFFF00;
      }
      else *pal++=tintpal(q2.type.cmyk.c,0xFFFF0000 & mask);
     }
     else
     if(key==KEYYELLOW)
     {
      if(q2.type.cmyk.y==0)
      {
       if((cs->flags & COLOUROVERPRINT) || cv->data.tint.overprint) *pal++=-1;
       else                                                 *pal++=0xFFFFFF00;
      }
      else *pal++=tintpal(q2.type.cmyk.y,0xFFFF00 & mask);
     }
     else
     if(key==KEYMAGENTA)
     {
      if(q2.type.cmyk.m==0)
      {
       if((cs->flags & COLOUROVERPRINT) || cv->data.tint.overprint) *pal++=-1;
       else                                                 *pal++=0xFFFFFF00;
      }
      else *pal++=tintpal(q2.type.cmyk.m,0xFF00FF00 & mask);
     }
     else
     if(key==KEYBLACK)
     {
      if(q2.type.cmyk.k==0)
      {
       if((cs->flags & COLOUROVERPRINT) || cv->data.tint.overprint) *pal++=-1;
       else                                                 *pal++=0xFFFFFF00;
      }
      else *pal++=tintpal(q2.type.cmyk.k,0);
     }
    }

    cv++;
   }
  }
 }

 return(NULL);
}




// default colour process, all colours except seps routed through here.

static os_error * sdprocess(viewstr * view,void * d,void * s,int size,
                            int dtype,int stype,cmsdatastr * scms,cmsdatastr * dcms)
{
	os_error * err;

	err=NULL;



 if(stype==PROCESST_CMYK)
 {
		if(dtype==PROCESST_RGB32)
		{
			xcolsepcmyk2rgb3232(view,(int*)s,(int*)d,size);
		}
		else
		if(dtype==PROCESST_BGR32)
		{
			xcolsepcmyk2bgr3232(view,(int*)s,(int*)d,size);
		}
	}
	else
 if(stype==PROCESST_RGB32)
 {
		memcpy(d,s,size*4);
 }
 else
 if(stype==PROCESST_BGR32)
 {
		memcpy(d,s,size*4);
 }
 else
 if(stype==PROCESST_BGR24)
 {
		memcpy(d,s,size*3);
 }
 else
 if(stype==PROCESST_RGB16)
 {
		memcpy(d,s,size*2);
 }
 else
 if(stype==PROCESST_BGR16)
 {
		memcpy(d,s,size*2);
 }
 else
 if(stype==PROCESST_PAL)
 {
		memcpy(d,s,size*4);
 }
 else
 if(stype==PROCESST_CMYK)
 {
		memcpy(d,s,size*4);
 }
 else
 if(stype==PROCESST_COLVAL)
 {
  colourvalue     * cv;
  int             * pal;
  colourstr       * cs;
		quadstr           q1;
		quadstr           q2;
		filestr         * file;
		int               tint;
	 int               rx;
		int               gx;
		int               bx;

  cv=(colourvalue*)s;
  pal=(int*)d;
		file=view->file;


		while(size--)
		{
   findcoloursp(cv->data.tint.key,&cs,file);

   if((cs->flags & COLOURTRANS) ||
       ((cs->flags & COLOURNOPRINT) && view->printview))
   {
    *pal++=-1;
   }
			else
			{
    if(cs->model.no==RGBMODEL)
    {
     tint=cv->data.tint.tint>>2;

      q1.type.rgb.r=
        ((MAXTINT2-tint)*MAXCV+tint*cs->model.data.quad.type.rgb.r)/MAXTINT2;
      q1.type.rgb.g=
        ((MAXTINT2-tint)*MAXCV+tint*cs->model.data.quad.type.rgb.g)/MAXTINT2;
      q1.type.rgb.b=
        ((MAXTINT2-tint)*MAXCV+tint*cs->model.data.quad.type.rgb.b)/MAXTINT2;


    }
    else
    if(cs->model.no==HSVMODEL)
    {
     tint=cv->data.tint.tint>>2;

     hsv2rgb(&cs->model.data.quad,&q1);

    }
    else
    if(cs->model.no==CMYKMODEL)
    {
     tint=cv->data.tint.tint>>2;

     q2.type.cmyk.c=(tint*cs->model.data.quad.type.cmyk.c)/MAXTINT2;
     q2.type.cmyk.m=(tint*cs->model.data.quad.type.cmyk.m)/MAXTINT2;
     q2.type.cmyk.y=(tint*cs->model.data.quad.type.cmyk.y)/MAXTINT2;
     q2.type.cmyk.k=(tint*cs->model.data.quad.type.cmyk.k)/MAXTINT2;

					colsepcmyk2rgb(file,&q2,&q1);
    }


    bx=(q1.type.rgb.b*255)/MAXCV;
    gx=(q1.type.rgb.g*255)/MAXCV;
    rx=(q1.type.rgb.r*255)/MAXCV;

    *pal=(bx<<24)|(gx<<16)|(rx<<8);

			 cv++;
			 pal++;
			}
		}

 }


	return(err);
}



static os_error * vprocess(viewstr * view,void * d,void * s,int size,
                           int dtype,int stype,cmsdatastr * scms,cmsdatastr * dcms)
{
 cscolourmodel=csscreencolourmodel;
 return(svprocess(view,d,s,size,dtype,stype,scms,dcms));
}



static os_error * vdefaultprocess(viewstr * view,void * d,void * s,int size,
                           int dtype,int stype,cmsdatastr * scms,cmsdatastr * dcms)
{
 cscolourmodel=csscreencolourmodel;
 return(sdprocess(view,d,s,size,dtype,stype,scms,dcms));
}




static os_error * pprocess(viewstr * view,void * d,void * s,int size,
                           int dtype,int stype,cmsdatastr * scms,cmsdatastr * dcms)
{
 cscolourmodel=csprintercolourmodel;
 return(svprocess(view,d,s,size,dtype,stype,scms,dcms));
}


static os_error * pdefaultprocess(viewstr * view,void * d,void * s,int size,
                           int dtype,int stype,cmsdatastr * scms,cmsdatastr * dcms)
{
 cscolourmodel=csprintercolourmodel;
 return(sdprocess(view,d,s,size,dtype,stype,scms,dcms));
}






os_error * colsepprocess(viewstr * view,void * d,void * s,int size,
                                                 int dtype,int stype)
{
 cscolourmodel=(view->printview)?csprintercolourmodel:csscreencolourmodel;

 if(stype==PROCESST_CMYK && dtype==PROCESST_RGB32)
                                     return(colsepcmyk2rgb3232((int*)s,(int*)d,size));

 return(NULL);
}



static int colsepkey(int n,int spot,filestr * file)
{
 colsepobjectstr * csp;
 int               i;


 if(file->hdr.colsep)
 {
  csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);

  for(i=0;i<csp->data.hdr.plates;i++)
  {
   if((int)csp->data.plate[i].spot==spot)
   {
    n--;
    if(n<0) return(csp->data.plate[i].colour);
   }
  }
 }

 return(0);
}








/* int csviewbits(int n,int spot,int bic,int eor) */

int csviewbits(int fp)
{
 int       n;
 int       spot;
 int       bic;
 int       eor;
 int       old;
 int       xnew;
 viewstr * view;
 filestr * file;
 int     * stack;

 stack=xstackptr();

 n=stack[fp];
 spot=stack[fp+1];
 bic=stack[fp+2];
 eor=stack[fp+3];

 view=getmenuview();
 file=view->file;


 if(bic || eor)
 {
  old=(view->process!=NULL) && (!(view->processvalue & COLDEFPROCESS)) &&
      (((spot<<SPOTSHIFT)|colsepkey(n,spot,file))==view->processvalue);
  old=old<<1;

  xnew=(old & (~bic)) ^ eor;

  if(n<0 || !xnew)
  {
			if(csscreencolourmodel==CSSCREENPROFILE)
			{
    view->process=vdefaultprocess;
    view->processvalue=COLDEFPROCESS;
			}
			else
			{
    view->process=NULL;
    view->processvalue=0;
			}
  }
  else
  {
   view->process=(void*)vprocess;
   view->processvalue=(spot<<SPOTSHIFT)|colsepkey(n,spot,file);
  }

  refreshview(view);
  return(xnew);
 }
 else  /* read */
 {
  if(view->process && (!(view->processvalue & COLDEFPROCESS)))
  {
   return((((spot<<SPOTSHIFT)|colsepkey(n,spot,file))==view->processvalue)<<1);
  }
  else
  {
   return(0);
  }
 }
}




// EVENT_COLOURCHANGE
// and	EVENT_DDLEND from csviewevent2()

os_error * csviewevent(int eventn,int userhandle,filestr * file,int data1)
{
 viewstr     * view;
 int           spot;
 int           key;
 colourstr   * cs;


 colsepinit(file);

 view=file->view;
 while(view)
 {
  if(view->process && (!(view->processvalue & COLDEFPROCESS)))
  {
   spot=(view->processvalue & SPOTMASK);
   key=view->processvalue & COLMASK;

   findcoloursp(key,&cs,file);

   if(cs->n!=key || ((cs->flags & COLOURPLATE)==COLOURPLATE)!=spot)
   {
				if(csscreencolourmodel==CSSCREENPROFILE)
				{
     view->process=vdefaultprocess;
     view->processvalue=COLDEFPROCESS;
				}
				else
				{
     view->process=NULL;
     view->processvalue=0;
				}
   }
  }

  view=view->next;
 }

 return(NULL);

 USE(data1);
 USE(userhandle);
 USE(eventn);

}



// EVENT_DDLEND

os_error * csviewevent2(int eventn,int userhandle,filestr * file,int data1)
{
 if(file) return(csviewevent(eventn,userhandle,file,data1));
 else     return(NULL);
}



// EVENT_VOPEN

os_error * csnewviewevent(int eventn,int userhandle,viewstr * view,int data1)
{

	if(csscreencolourmodel==CSSCREENPROFILE)
	{
  view->process=vdefaultprocess;
  view->processvalue=COLDEFPROCESS;
	}

 return(NULL);
}



// EVENT_NEWCOLOURMODEL

os_error * csnewcolourmodel(int eventn,int userhandle,void * data,int data1)
{
	os_error * err;
	filestr  * file;
	viewstr  * view;

	err=NULL;


 file=firstfilep();
	while(file)
	{
		view=file->view;
		while(view)
		{
			if(view->process==NULL || (view->processvalue & COLDEFPROCESS))
			{
   	if(csscreencolourmodel==CSSCREENPROFILE)
 			{
     view->process=vdefaultprocess;
     view->processvalue=COLDEFPROCESS;
 			}
 			else
 			{
     view->process=NULL;
     view->processvalue=0;
 			}
			}
			view=view->next;
		}
		file=file->next;
	}



	return(err);
}







static int        currentfreq;
static int        currentangle;
static int        currentpsscreen;
static int        currentspotnumber;
static int        currentseps;

       int        currentcolour;
       int        currentspot;
static prjobstr * currentprjob;



int csreadfrequency(int fp)
{
 return(currentfreq);
 USE(fp);
}



int csreadangle(int fp)
{
 return(currentangle);
 USE(fp);
}



int csreadpsscreen(int fp)
{
 return(currentpsscreen);
 USE(fp);
}



int csreadspot(int fp)
{
 return(currentspotnumber);
 USE(fp);
}



int csreadseps(int fp)
{
 return(currentseps);
 USE(fp);
}



int csreadcolour(int fp)
{
 viewstr   * view;
 filestr   * file;
 colourstr * cs;
 char        name[COLNAMELEN];
 int       * stack;


 view=currentprjob->view;
 file=view->file;

 findcoloursp(currentcolour,&cs,file);
 xzstrncpy(name,cs->name,sizeof(name));

 stack=xstackptr();
 assignstring(stack[fp],name);

 return(currentcolour);
}




os_error * colsepprint(void * prjob,int code)
{
 colsepobjectstr * csp;
 int               i;
 filestr         * file;
 viewstr         * view;
 int               n;
// char            * p;
// int               c;


 currentprjob=(prjobstr*)prjob;
 view=((prjobstr*)prjob)->view;
 file=view->file;


 if(code==CSPR_STARTJOB)
 {
  ((prjobstr*)prjob)->separations=1;
  ((prjobstr*)prjob)->doseparations=currentseps=0;

		if(csprintercolourmodel==CSPRINTERPROFILE)
		{
   view->process=pdefaultprocess;
   view->processvalue=COLDEFPROCESS;
		}

  if(file->hdr.colsep)
  {
   csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);

   if(csp->data.hdr.doseparations)
   {
    n=0;
    for(i=0;i<csp->data.hdr.plates;i++)
    {
     if(csp->data.plate[i].print)
     {
      if(n==0)
      {
       currentfreq=csp->data.plate[i].frequency;
       currentangle=csp->data.plate[i].angle;
       currentpsscreen=csp->data.plate[i].psscreen;
       currentspotnumber=csp->data.plate[i].spotnumber;
       currentspot=csp->data.plate[i].spot;
      }
      n++;
     }
    }

    if(n)
    {
     ((prjobstr*)prjob)->doseparations=currentseps=1;
     ((prjobstr*)prjob)->separations=n;
    }
   }
   else
   {
    for(i=0;i<csp->data.hdr.plates;i++)
    {
     if(csp->data.plate[i].colour==KEYBLACK || i==0)
     {
      currentfreq=csp->data.plate[i].frequency;
      currentangle=csp->data.plate[i].angle;
      currentpsscreen=csp->data.plate[i].psscreen;
      currentspotnumber=csp->data.plate[i].spotnumber;
      currentspot=csp->data.plate[i].spot;
      currentcolour=csp->data.plate[i].colour;
     }
    }
   }
  }
  else
  {
   currentpsscreen=0;

  }
 }
 else
 if(code==CSPR_STARTSEP)
 {
  /* map prjob->separation to sep. index */

  if(((prjobstr*)prjob)->doseparations)
  {
   csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);

   n=-1;
   for(i=0;i<csp->data.hdr.plates;i++)
   {
    if(csp->data.plate[i].print) n++;
    if(n==((prjobstr*)prjob)->separation)
    {
     view->process=(void*)pprocess;
     view->processvalue=i;

     currentfreq=csp->data.plate[i].frequency;
     currentangle=csp->data.plate[i].angle;
     currentpsscreen=csp->data.plate[i].psscreen;
     currentspotnumber=csp->data.plate[i].spotnumber;
     currentspot=csp->data.plate[i].spot;
     currentcolour=csp->data.plate[i].colour;

     break;
    }
   }
   event(EVENT_PRSTARTSEPARATION,view,(int)prjob);
  }
 }
 else
 if(code==CSPR_ENDSEP)
 {
  event(EVENT_PRENDSEPARATION,view,(int)prjob);

		if(csprintercolourmodel==CSPRINTERPROFILE)
		{
   view->process=pdefaultprocess;
   view->processvalue=COLDEFPROCESS;
		}
		else
		{
   view->process=NULL;
   view->processvalue=0;
		}
 }
 else
 if(code==CSPR_STARTCOPY)
 {
#ifdef NEVER
  if(!((prjobstr*)prjob)->doseparations)
  {
   if((p=getenv("Printer$AllSeparations"))!=NULL)
   {
    p=getenv("Printer$Separation");
    if(p)
    {
     c=*p;

     if(file->hdr.colsep)
     {
      csp=(colsepobjectstr*)fob_find(file->hdr.colsep,file);

      for(i=0;i<csp->data.hdr.plates;i++)
      {
       if((csp->data.plate[i].colour==KEYBLACK && c=='K') ||
          (csp->data.plate[i].colour==KEYCYAN && c=='C') ||
          (csp->data.plate[i].colour==KEYMAGENTA && c=='M') ||
          (csp->data.plate[i].colour==KEYYELLOW && c=='Y'))
       {
        view->process=(void*)pprocess;
        view->processvalue=i|COPYSEP;
        break;
       }
      }
     }
    } 
   }
  }
#endif
 }
 else
 if(code==CSPR_ENDCOPY)
 {
#ifdef NEVER
  if(!((prjobstr*)prjob)->doseparations)
  {
   view->process=NULL;
   view->processvalue=0;
  }
#endif
 }

 return(NULL);
}




int colsepcurrentplate(void * prjob)
{
 return(currentcolour);
 USE(prjob);
}




/*****************************************************************************/


static int        currentpxfreq;
static int        currentpxangle;
static int        currentpxpsscreen;
static int        currentpxspot;



int csreadpxfrequency(int fp)
{
 return(currentpxfreq);
 USE(fp);
}



int csreadpxangle(int fp)
{
 return(currentpxangle);
 USE(fp);
}



int csreadpxpsscreen(int fp)
{
 return(currentpxpsscreen);
 USE(fp);
}



int csreadpxspot(int fp)
{
 return(currentpxspot);
 USE(fp);
}






os_error * colseppict(viewredrawstr * v,int pict,int process,int code)
{
 processscreenstr * scr;
 processobjectstr * procp;
 int                i;


 if(v->isprinter)
 {
  if(code==CSPX_START)
  {
   currentpxfreq=currentfreq;
   currentpxangle=currentangle;
   currentpxpsscreen=0; /*  was currentpsscreen; */
   currentpxspot=currentspotnumber;

   if(process)
   {
    procp=(processobjectstr*)fob_find(process,v->file);
    if(procp)
    {
     scr=(processscreenstr*)processfindtag(procp,PROCSCRTAG);
     if(scr)
     {
      for(i=0;i<scr->plates;i++)
      {
       if((currentcolour==scr->plate[i].colour && currentseps) ||
          ((scr->plate[i].colour==KEYBLACK) && !currentseps))
       {
        currentpxfreq=scr->plate[i].frequency;
        currentpxangle=scr->plate[i].angle;
        currentpxpsscreen=scr->plate[i].psscreen;
        currentpxspot=scr->plate[i].spotnumber;
        break;
       }
      }
     }
    }
   }

   event(EVENT_PRSTARTPICT,v->view,(int)v);
  }
  else
  if(code==CSPX_END)
  {
   event(EVENT_PRENDPICT,v->view,(int)v);
  }
 }


 return(NULL);

 USE(pict);
}



